CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Main
  cognew(@entry, 0) 'Launch new cog


DAT
              ORG 0 'Begin at Cog RAM addr 0
entry
              mov       dira, _LED_Pin_No 'Set IO-Pin to output 

:Check_XPulse mov       _X_Pulse_State,INA          'load bits of INA-register into _X_Pulse_State

              'filter that 1 bit of that IO-Pin where x-pulse is connected to
              'set carry-flag if result has a odd number of high bits
              'as _X_Pulse_Pin_No contains only 1 single bit with value 1 this detects a HIGH on the IO-Pin _X_Pulse_Pin_No  
              and       _X_Pulse_State, _X_Pulse_Pin_No WC    
        if_c  jmp #:burst_start 'only if carry-flag is set jump to subroutine with label burst_pulses 
              jmp #:Check_XPulse 'if jmp in the line above is not executed jump back to label Check_XPulse 


              'load PASM-"variable" _LoopCounter with value 400 as IO-Pin is toggled on/off
              'we need 2*200=400 loops 
:burst_start  mov       _LoopCounter,#400 ' 
              mov       _actual_Time, cnt 'load actual value of cnt into PASM-"variable" _Time
              'at a clock of 80 MHz 80 Clockticks is 1 microsecond
              'as O-Pin is toggled ON/OFF 1 microsecond ON 1 microsecond off
              'this results in a freqency of 500 kHz    
              add       _actual_Time, _Delay'_TestDelay'_Delay 

              'Wait for cnt to match the value of _Time
              'then the PASM-command waitcnt presets the matchregister to a new value
              'which is calculated as actual matching value + _Delay 
:burst_loop   waitcnt   _actual_Time, _Delay'_TestDelay '_Delay  
              xor       outa, _LED_Pin_No              'Toggle IO-Pin

              'decrease _LoopCntr and jump to label burst_loop as long as _LoopCntr > 0
              djnz      _LoopCounter, #:burst_loop'#:burst_loop         
              mov       outa, #0
              jmp       #:Check_XPulse 'burst pulses is done jump to wait for IO-pin X_Pulse to be high 


'always put longs and res's BEHIND the last PASM-command 
_LED_Pin_No     long |< 16 'IO-Pin number
_X_Pulse_Pin_No long |< 15

_Delay          long 40 'Clock cycles to delay
_TestDelay      long 20_000_000

_actual_Time    res 1 'reserve 1 long for System Counter value "PASM-variable"
_LoopCounter    res 1 'reserve 1 long for the n-repeated loop
_X_Pulse_State  res 1 'reserve 1 long for the state of the X_Pulse input-pin

                fit